// EllipsisTest.cpp
// Copyright (C) 2018 Katayama Hirofumi MZ <katayama.hirofumi.mz@gmail.com>.
// This file is public domain software.
#include <windows.h>
#include <windowsx.h>

HWND g_hStc1;
HWND g_hStc2;
HWND g_hStc3;
HWND g_hStc4;
HWND g_hStc5;
HWND g_hStc6;

void OnEdt(HWND hwnd)
{
    INT width = GetDlgItemInt(hwnd, edt2, NULL, TRUE);

    RECT rc;
    GetWindowRect(g_hStc1, &rc);
    SetWindowPos(g_hStc1, NULL, 0, 0, width, rc.bottom - rc.top,
                 SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOZORDER | SWP_NOOWNERZORDER);
    GetWindowRect(g_hStc2, &rc);
    SetWindowPos(g_hStc2, NULL, 0, 0, width, rc.bottom - rc.top,
                 SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOZORDER | SWP_NOOWNERZORDER);
    GetWindowRect(g_hStc3, &rc);
    SetWindowPos(g_hStc3, NULL, 0, 0, width, rc.bottom - rc.top,
                 SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOZORDER | SWP_NOOWNERZORDER);

    GetWindowRect(g_hStc4, &rc);
    SetWindowPos(g_hStc4, NULL, 0, 0, width, rc.bottom - rc.top,
                 SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOZORDER | SWP_NOOWNERZORDER);
    GetWindowRect(g_hStc5, &rc);
    SetWindowPos(g_hStc5, NULL, 0, 0, width, rc.bottom - rc.top,
                 SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOZORDER | SWP_NOOWNERZORDER);
    GetWindowRect(g_hStc6, &rc);
    SetWindowPos(g_hStc6, NULL, 0, 0, width, rc.bottom - rc.top,
                 SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOZORDER | SWP_NOOWNERZORDER);

    TCHAR szText[256];
    GetDlgItemText(hwnd, edt1, szText, ARRAYSIZE(szText));

    SetDlgItemText(hwnd, stc1, szText);
    SetDlgItemText(hwnd, stc2, szText);
    SetDlgItemText(hwnd, stc3, szText);
    SetDlgItemText(hwnd, stc4, szText);
    SetDlgItemText(hwnd, stc5, szText);
    SetDlgItemText(hwnd, stc6, szText);
}

void DrawTextStatic_OnPaint(HWND hwnd)
{
    PAINTSTRUCT ps;
    RECT rc;
    GetClientRect(hwnd, &rc);
    TCHAR szText[256];
    GetWindowText(hwnd, szText, ARRAYSIZE(szText));
    if (HDC hdc = BeginPaint(hwnd, &ps))
    {
        SelectObject(hdc, GetWindowFont(hwnd));
        FillRect(hdc, &rc, (HBRUSH)(COLOR_3DFACE + 1));
        if (hwnd == g_hStc4)
            DrawText(hdc, szText, -1, &rc, DT_EDITCONTROL | DT_NOPREFIX | DT_END_ELLIPSIS | DT_SINGLELINE);
        if (hwnd == g_hStc5)
            DrawText(hdc, szText, -1, &rc, DT_EDITCONTROL | DT_NOPREFIX | DT_PATH_ELLIPSIS | DT_SINGLELINE);
        if (hwnd == g_hStc6)
            DrawText(hdc, szText, -1, &rc, DT_EDITCONTROL | DT_NOPREFIX | DT_WORD_ELLIPSIS | DT_SINGLELINE);
        EndPaint(hwnd, &ps);
    }
}

void DrawTextStatic_OnNCDestroy(HWND hwnd)
{
    WNDPROC fn = (WNDPROC)GetWindowLongPtr(hwnd, GWLP_USERDATA);
    SetWindowLongPtr(hwnd, GWLP_WNDPROC, (LONG_PTR)fn);
    SetWindowLongPtr(hwnd, GWLP_USERDATA, 0);
}

LRESULT CALLBACK
DrawTextStatic_WindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    LRESULT result;
    switch (uMsg)
    {
        HANDLE_MSG(hwnd, WM_PAINT, DrawTextStatic_OnPaint);
        HANDLE_MSG(hwnd, WM_NCDESTROY, DrawTextStatic_OnNCDestroy);
    case WM_SETTEXT:
        result = CallWindowProc((WNDPROC)GetWindowLongPtr(hwnd, GWLP_USERDATA), hwnd, uMsg, wParam, lParam);
        InvalidateRect(hwnd, NULL, TRUE);
        return result;
    default:
        return CallWindowProc((WNDPROC)GetWindowLongPtr(hwnd, GWLP_USERDATA), hwnd, uMsg, wParam, lParam);
    }
}

BOOL OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam)
{
    g_hStc1 = GetDlgItem(hwnd, stc1);
    g_hStc2 = GetDlgItem(hwnd, stc2);
    g_hStc3 = GetDlgItem(hwnd, stc3);

    g_hStc4 = GetDlgItem(hwnd, stc4);
    g_hStc5 = GetDlgItem(hwnd, stc5);
    g_hStc6 = GetDlgItem(hwnd, stc6);

    WNDPROC fn;
    fn = SubclassWindow(g_hStc4, DrawTextStatic_WindowProc);
    SetWindowLongPtr(g_hStc4, GWLP_USERDATA, (LONG_PTR)fn);
    fn = SubclassWindow(g_hStc5, DrawTextStatic_WindowProc);
    SetWindowLongPtr(g_hStc5, GWLP_USERDATA, (LONG_PTR)fn);
    fn = SubclassWindow(g_hStc6, DrawTextStatic_WindowProc);
    SetWindowLongPtr(g_hStc6, GWLP_USERDATA, (LONG_PTR)fn);

    RECT rc;
    GetWindowRect(g_hStc1, &rc);
    SetDlgItemInt(hwnd, edt2, rc.right - rc.left, TRUE);

    SendDlgItemMessage(hwnd, edt1, EM_SETLIMITTEXT, 255, 0);
    SendDlgItemMessage(hwnd, edt2, EM_SETLIMITTEXT, 255, 0);

    OnEdt(hwnd);

    InvalidateRect(g_hStc4, NULL, TRUE);
    InvalidateRect(g_hStc5, NULL, TRUE);
    InvalidateRect(g_hStc6, NULL, TRUE);
    return TRUE;
}

void OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
    switch (id)
    {
    case IDOK:
    case IDCANCEL:
        if (codeNotify == 0 || codeNotify == BN_CLICKED)
        {
            EndDialog(hwnd, id);
        }
        break;
    case edt1:
    case edt2:
        OnEdt(hwnd);
        break;
    }
}

INT_PTR CALLBACK
DialogProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
        HANDLE_MSG(hwnd, WM_INITDIALOG, OnInitDialog);
        HANDLE_MSG(hwnd, WM_COMMAND, OnCommand);
    }
    return 0;
}

INT WINAPI
WinMain(HINSTANCE   hInstance,
        HINSTANCE   hPrevInstance,
        LPSTR       lpCmdLine,
        INT         nCmdShow)
{
    DialogBox(hInstance, MAKEINTRESOURCE(1), NULL, DialogProc);
    return 0;
}
